# $Id: killerfeature.tcl 83 2007-12-24 19:25:07Z kostix $
# "Killer Feature" -- account removal support plugin for Tkabber.
# Written by Konstantin Khomoutov <flatworm@users.sourceforge.net>

namespace eval killerfeature {
	variable state

	hook::add finload_hook [namespace current]::init
	hook::add connected_hook [namespace current]::update_state
	hook::add disconnected_hook [namespace current]::update_state
}

proc killerfeature::init args {
	set m [[. cget -menu] entrycget Tkabber -menu]
	set ix [$m index [::msgcat::mc "Log out with reason..."]]
	$m insert [incr ix] command \
		-label [::msgcat::mc "Delete account..."] \
		-command [namespace current]::zap_dialog
}

proc killerfeature::update_state args {
	set enabled [expr {[llength [jlib::connections]] != 0}]
}

proc killerfeature::myentry m {
	set path [list Tkabber \
		[::msgcat::mc "Log out with reason"] \
		[::msgcat::mc "Delete account..."]]
	foreach entry [lrange $path 0 end-1] {
		set m [$m entrycget $entry -menu]
	}

	$m index [lindex $path end]
}

proc killerfeature::zap_dialog {} {
	set connids [jlib::connections]
	if {[llength $connids] == 0} return

	set w [Dialog .zapaccount \
		-default 0 -cancel 1 -separator on \
		-title [::msgcat::mc "Delete account(s)"]]
	$w add -text OK
	$w add -text [::msgcat::mc "Cancel"]

	set f [$w getframe]

	set accs [list]
	foreach connid $connids {
		lappend accs [list [jlib::connection_bare_jid $connid] $connid]
	}
	set accs [lsort -unique -index 0 $accs]

	variable state
	array unset state *
	foreach acc $accs {
		lassign $acc jid connid
		checkbutton $f.$connid -text $jid \
			-variable [namespace current]::state($connid)
		pack $f.$connid -side top -anchor w
	}

	set choice [$w draw]
	destroy $w
	if {$choice != 0} return

	foreach acc $accs {
		lassign $acc jid connid
		if {$state($connid)} {
			zap $connid
		}
	}

	array unset state *
}

proc killerfeature::zap connid {
	jlib::send_iq set \
		[jlib::wrapper:createtag query \
			-vars [list xmlns jabber:iq:register] \
			-subtags [list [jlib::wrapper:createtag remove]]] \
		-connection $connid \
		-command [list [namespace current]::parse_iq_resp $connid]
	logout $connid
}

proc killerfeature::parse_iq_resp {connid res child} {
}

